// Code generated by gopkg.in/reform.v1. DO NOT EDIT.

package db

import (
	"fmt"
	"strings"

	"gopkg.in/reform.v1"
	"gopkg.in/reform.v1/parse"
)

type transactionViewType struct {
	s parse.StructInfo
	z []interface{}
}

// Schema returns a schema name in SQL database ("").
func (v *transactionViewType) Schema() string {
	return v.s.SQLSchema
}

// Name returns a view or table name in SQL database ("transaction").
func (v *transactionViewType) Name() string {
	return v.s.SQLName
}

// Columns returns a new slice of column names for that view or table in SQL database.
func (v *transactionViewType) Columns() []string {
	return []string{"id", "wallet_id", "type", "target", "direction", "reference", "reference_id", "before", "amount", "after", "created"}
}

// NewStruct makes a new struct for that view or table.
func (v *transactionViewType) NewStruct() reform.Struct {
	return new(Transaction)
}

// TransactionView represents transaction view or table in SQL database.
var TransactionView = &transactionViewType{
	s: parse.StructInfo{Type: "Transaction", SQLSchema: "", SQLName: "transaction", Fields: []parse.FieldInfo{{Name: "Id", Type: "int64", Column: "id"}, {Name: "WalletId", Type: "int64", Column: "wallet_id"}, {Name: "Type", Type: "protobufWallet.TransactionType", Column: "type"}, {Name: "Target", Type: "protobufWallet.TransactionTarget", Column: "target"}, {Name: "Direction", Type: "protobufWallet.TransactionDirection", Column: "direction"}, {Name: "Reference", Type: "protobufWallet.TransactionReference", Column: "reference"}, {Name: "ReferenceId", Type: "string", Column: "reference_id"}, {Name: "Before", Type: "float64", Column: "before"}, {Name: "Amount", Type: "float64", Column: "amount"}, {Name: "After", Type: "float64", Column: "after"}, {Name: "Created", Type: "*time.Time", Column: "created"}}, PKFieldIndex: -1},
	z: new(Transaction).Values(),
}

// String returns a string representation of this struct or record.
func (s Transaction) String() string {
	res := make([]string, 11)
	res[0] = "Id: " + reform.Inspect(s.Id, true)
	res[1] = "WalletId: " + reform.Inspect(s.WalletId, true)
	res[2] = "Type: " + reform.Inspect(s.Type, true)
	res[3] = "Target: " + reform.Inspect(s.Target, true)
	res[4] = "Direction: " + reform.Inspect(s.Direction, true)
	res[5] = "Reference: " + reform.Inspect(s.Reference, true)
	res[6] = "ReferenceId: " + reform.Inspect(s.ReferenceId, true)
	res[7] = "Before: " + reform.Inspect(s.Before, true)
	res[8] = "Amount: " + reform.Inspect(s.Amount, true)
	res[9] = "After: " + reform.Inspect(s.After, true)
	res[10] = "Created: " + reform.Inspect(s.Created, true)
	return strings.Join(res, ", ")
}

// Values returns a slice of struct or record field values.
// Returned interface{} values are never untyped nils.
func (s *Transaction) Values() []interface{} {
	return []interface{}{
		s.Id,
		s.WalletId,
		s.Type,
		s.Target,
		s.Direction,
		s.Reference,
		s.ReferenceId,
		s.Before,
		s.Amount,
		s.After,
		s.Created,
	}
}

// Pointers returns a slice of pointers to struct or record fields.
// Returned interface{} values are never untyped nils.
func (s *Transaction) Pointers() []interface{} {
	return []interface{}{
		&s.Id,
		&s.WalletId,
		&s.Type,
		&s.Target,
		&s.Direction,
		&s.Reference,
		&s.ReferenceId,
		&s.Before,
		&s.Amount,
		&s.After,
		&s.Created,
	}
}

// View returns View object for that struct.
func (s *Transaction) View() reform.View {
	return TransactionView
}

// check interfaces
var (
	_ reform.View   = TransactionView
	_ reform.Struct = (*Transaction)(nil)
	_ fmt.Stringer  = (*Transaction)(nil)
)

func init() {
	parse.AssertUpToDate(&TransactionView.s, new(Transaction))
}
